## getdns 1.5.2

=== debian/changelog ===
getdns (1.5.2-4) unstable; urgency=medium

  * Team upload.
  * debian/control:
    - B-D: Remove doxygen, seems not used at all.
  * debian/stubby.service:
    - Update from upstream.
  * debian/rules:
    - Fix CURRENT_DATE setting.
  * debian/tests:
    - Add procps as tests dependency, since we use "ps" command.
    - Add more comments in stubby test script.

 -- Roger Shimizu <rosh@debian.org>  Sun, 31 May 2020 19:53:16 +0900

getdns (1.5.2-3) unstable; urgency=medium

  * Team upload.
  * d/tests:
    - Add a few 443 port DoT DNS upstream server.
    - Use IPv4 localhost address to test.
    - Test both systemd service port, and the server (port=5533) started
      by ourselves.
  * d/stubby.service: Add default configuration file path to start
    the service (Closes: #961624).

 -- Roger Shimizu <rosh@debian.org>  Fri, 29 May 2020 00:06:11 +0900

getdns (1.5.2-2) unstable; urgency=medium

  * Team upload.
  * d/tests: Make stubby daemon listen on an unknown port and test
    10 times.

 -- Roger Shimizu <rosh@debian.org>  Wed, 27 May 2020 22:30:25 +0900

getdns (1.5.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release 1.5.2
    - Two small trust anchor fetcher fixes.
    - Enable server side and update client side TCP Fast Open
      implementation.
    - Fix insecure delegation detection while scheduling.
    - Escape backslashed when printing in JSON format.
    - Use GnuTLS instead of OpenSSL for TLS with the --with-gnutls
      option to configure.  libcrypto (from OpenSSL) still needed
      for Zero configuration DNSSEC.
    - DOA rr-type
    - AMTRELAY rr-type
  * d/control: Add Rules-Requires-Root: no
  * d/libgetdns10.symbols: Add Build-Depends-Package field.
  * Add debian/upstream/metadata

 -- Roger Shimizu <rosh@debian.org>  Tue, 26 May 2020 21:37:21 +0900

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

CURRENT_DATE=$(shell date -u --rfc-3339=seconds --date "@$$SOURCE_DATE_EPOCH")

export DPKG_GENSYMBOLS_CHECK_LEVEL=4
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_autoreconf:
	automake -a || true
	dh_autoreconf

override_dh_auto_configure:
	dh_auto_configure -- \
		--with-libevent \
		--with-libev \
		--with-libuv \
		--with-trust-anchor=/usr/share/dns/root.key \
		--with-current-date="$(CURRENT_DATE)" \
		--with-stubby

override_dh_install:
	-rm -rf $(CURDIR)/debian/tmp/usr/share/doc
	dh_install -X.la

override_dh_missing:
	dh_missing -X.la --fail-missing

override_dh_auto_test:
	# remote tests fail when there's no connectivity or the connectivity is restrained
	-dh_auto_test

=== debian/tests/control ===
Tests: stubby
Depends: stubby, knot-dnsutils, procps
Restrictions: allow-stderr

## getdns 1.6.0

=== stubby/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)

if (POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif ()

# The following must be set BEFORE doing project() or enable_language().
if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type defined; defaulting to 'Debug'")
  set(CMAKE_BUILD_TYPE "Debug" CACHE STRING
    "The type of build. Possible values are: Debug, Release, RelWithDebInfo and MinSizeRel.")
endif ()

set(PACKAGE "stubby")
set(PACKAGE_NAME "Stubby")
set(PACKAGE_VERSION "0.3.0")
set(PACKAGE_BUGREPORT "team@getdnsapi.net")
set(RELEASE_CANDIDATE "")

set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}${RELEASE_CANDIDATE}")
set(PACKAGE_TARNAME "${PACKAGE}-${PACKAGE_VERSION}${RELEASE_CANDIDATE}")

set(STUBBY_PACKAGE "${PACKAGE}")
set(STUBBY_PACKAGE_STRING "${PACKAGE_STRING}")

project (stubby VERSION ${PACKAGE_VERSION} LANGUAGES C)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")

include(CheckIncludeFile)
include(CheckSymbolExists)
include(GNUInstallDirs)
include(CMakeDependentOption)

# Options.
find_package(Libsystemd)
if (Libsystemd_FOUND)
  option(ENABLE_SYSTEMD "Enable systemd support." ON)
endif()

# Directories
if (DEFINED CMAKE_INSTALL_FULL_RUNSTATEDIR)
  set(RUNSTATEDIR "${CMAKE_INSTALL_FULL_RUNSTATEDIR}")
else ()
  set(RUNSTATEDIR "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/run")
endif ()
install(DIRECTORY
  DESTINATION ${RUNSTATEDIR}
  DIRECTORY_PERMISSIONS
  OWNER_READ OWNER_WRITE OWNER_EXECUTE
  GROUP_READ GROUP_EXECUTE
  WORLD_READ WORLD_EXECUTE
  )
set(STUBBYCONFDIR "${CMAKE_INSTALL_FULL_SYSCONFDIR}/stubby")

find_package(Libyaml REQUIRED)

if (WIN32)
  set(STUBBY_ON_WINDOWS 1)
endif ()

check_include_file(os/log.h HAVE_OS_LOG_H)
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)

option(ENABLE_DEBUG_ALL "Enable all debugging messages.")
cmake_dependent_option(ENABLE_DEBUG_SERVER "Enable server debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
set(SERVER_DEBUG ${ENABLE_DEBUG_SERVER})


check_symbol_exists(getopt "unistd.h" HAVE_GETOPT)

# Does the compiler accept the "format" attribute?
try_compile(HAVE_ATTR_FORMAT
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/tests/test_format_attr.c
  )
# Does the compiler accept the "unused" attribute?
try_compile(HAVE_ATTR_UNUSED
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/tests/test_unused_attr.c
  )

configure_file(cmake/include/cmakeconfig.h.in config.h)
set(ETCDIR "${STUBBYCONFDIR}")
configure_file(doc/stubby.1.in stubby.1 @ONLY)

add_executable(stubby
  src/stubby.c
  src/yaml/convert_yaml_to_json.c
  src/sldns/sbuffer.c
  )
if (NOT HAVE_GETOPT)
  target_sources(stubby PRIVATE src/compat/getopt.c)
  target_include_directories(stubby PRIVATE src/compat)
endif ()

target_include_directories(stubby PRIVATE src ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(stubby PRIVATE Libyaml::Libyaml)
if (ENABLE_SYSTEMD)
  target_link_libraries(stubby PRIVATE Libsystemd::Libsystemd)
endif()
# Are we being built from getdns? If so, use the build tree getdns.
if (TARGET getdns)
  target_link_libraries(stubby PRIVATE getdns)
else ()
  find_package(Getdns "1.5.0" REQUIRED)
  target_link_libraries(stubby PRIVATE Getdns::Getdns)
endif ()
set_property(TARGET stubby PROPERTY C_STANDARD 11)

install(TARGETS stubby DESTINATION bin)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/stubby.1 DESTINATION share/man/man1)
install(FILES AUTHORS COPYING ChangeLog NEWS README.md DESTINATION share/doc/stubby)

# Ensure the file gets CRLF line endings on Windows.
file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/stubby.yml INPUT ${CMAKE_CURRENT_SOURCE_DIR}/stubby.yml.example)
# Copy to destination iff no destination file exists.
install(CODE "\
  set(targetdir ${STUBBYCONFDIR})\n\
  if (\$ENV{DESTDIR})\n\
    set(targetdir \$ENV{DESTDIR}/\${targetdir})\n\
  endif ()\n\
  if (NOT EXISTS \${targetdir}/stubby.yml)\n\
    file(COPY ${CMAKE_CURRENT_BINARY_DIR}/stubby.yml DESTINATION \${targetdir})\n\
  endif ()")

if (APPLE)
  find_library(security Security REQUIRED)
  add_executable(stubby-ui-helper macos/stubby-ui-helper.c)
  target_include_directories(stubby-ui-helper PRIVATE ${CMAKE_CURRENT_BINARY_DIR})
  target_link_libraries(stubby-ui-helper ${security})

  install(FILES macos/stubby-setdns-macos.sh DESTINATION sbin)
endif ()

=== debian/changelog ===
getdns (1.6.0-2build1) jammy; urgency=medium

  * No-change rebuild against libssl3

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 08 Dec 2021 23:31:49 +0000

getdns (1.6.0-2) unstable; urgency=medium

  * Team upload.
  * debian/control:
    - Mark libgetdns-dev as Multi-Arch: same

 -- Roger Shimizu <rosh@debian.org>  Sun, 06 Dec 2020 03:01:19 +0900

getdns (1.6.0-1) unstable; urgency=low

  * Team upload.
  * Upload to unstable.
  * debian/watch:
    - Better adapt various rc/beta/alpha version.

 -- Roger Shimizu <rosh@debian.org>  Wed, 23 Sep 2020 00:29:54 +0900

getdns (1.6.0-1~exp2) experimental; urgency=medium

  * Team upload.
  * debian/stubby.service:
    - Revert previous revert, since CI shows it fails again.
      Now we have to specify the config file path for stubby.

 -- Roger Shimizu <rosh@debian.org>  Sun, 31 May 2020 20:33:47 +0900

getdns (1.6.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release 1.6.0
    - Migration of build system to cmake.
    - New symbols with libnettle >= 3.4.
    - answer_ipv4_address and answer_ipv6_address in reply and response
      dicts.
    - Record and guard UDP max payload size with servers.
    - Run only offline-tests option with:
      src/test/tpkg/run-offline-only.sh
    - Include the packet the stub resolver sent to the upstream
      the call_reporting dict.
    - Build eventloop support libraries if event libraries are available.
  * debian/control:
    - B-D: Add cmake, the new build system.
    - B-D: Remove doxygen, seems not used at all.
  * debian/copyright:
    - Remove makefile which is erased from upstream.
  * debian/patches:
    - Add 2 patches to make the cmake build works.
  * debian/stubby.service:
    - Update from upstream.
    - Revert the default config file in service file.
      Let's see the CI result.
  * debian/libgetdns10.symbols:
    - Update symbols file.
  * debian/rules:
    - Update to use cmake, and cmake options.

 -- Roger Shimizu <rosh@debian.org>  Fri, 29 May 2020 19:00:18 +0900

getdns (1.5.2-5) unstable; urgency=medium

  * Team upload.
  * d/t/control, d/t/stubby:
    - [from ubuntu] Skip test if we don't have internet connection.

 -- Roger Shimizu <rosh@debian.org>  Thu, 09 Jul 2020 23:53:35 +0900

=== debian/control ===
Source: getdns
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: getdns packagers <getdns@packages.debian.org>
Uploaders:
 Ondřej Surý <ondrej@debian.org>,
 Scott Kitterman <scott@kitterman.com>,
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
Build-Depends:
 check,
 cmake,
 debhelper (>= 11~),
 libbsd-dev,
 libev-dev,
 libevent-dev,
 libexpat-dev,
 libidn2-dev,
 libldns-dev,
 libunbound-dev,
 libuv1-dev,
 libyaml-dev,
 unbound-anchor,
Standards-Version: 4.3.0
Rules-Requires-Root: no
Section: libs
Homepage: https://getdnsapi.net/
Vcs-Git: https://salsa.debian.org/dns-team/getdns.git
Vcs-Browser: https://salsa.debian.org/dns-team/getdns

Package: libgetdns-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libgetdns10 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Description: modern asynchronous DNS API (development)
 getdns is a modern asynchronous DNS API.  It implements DNS entry
 points from a design developed and vetted by application developers,
 in an API specification edited by Paul Hoffman.  This API intends to
 offer application developers a modernized and flexible way to access
 DNS security (DNSSEC) and other powerful new DNS features; a
 particular hope is to inspire application developers towards
 innovative security solutions in their applications.
 .
 This is the full development version of the library.

Package: libgetdns10
Multi-Arch: same
Architecture: any
Depends:
 dns-root-data,
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 libgetdns0 (>= 0.1.5-1~),
Replaces:
 libgetdns0 (>= 0.1.5-1~),
Description: modern asynchronous DNS API (shared library)
 getdns is a modern asynchronous DNS API.  It implements DNS entry
 points from a design developed and vetted by application developers,
 in an API specification edited by Paul Hoffman.  This API intends to
 offer application developers a modernized and flexible way to access
 DNS security (DNSSEC) and other powerful new DNS features; a
 particular hope is to inspire application developers towards
 innovative security solutions in their applications.
 .
 This is the runtime package of the library.

Package: getdns-utils
Architecture: any
Section: net
Depends:
 libgetdns10 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 stubby,
Description: modern asynchronous DNS API (utils)
 getdns is a modern asynchronous DNS API.  It implements DNS entry
 points from a design developed and vetted by application developers,
 in an API specification edited by Paul Hoffman.  This API intends to
 offer application developers a modernized and flexible way to access
 DNS security (DNSSEC) and other powerful new DNS features; a
 particular hope is to inspire application developers towards
 innovative security solutions in their applications.
 .
 This package contains getdns-query utility.

Package: stubby
Architecture: any
Section: net
Depends:
 libgetdns10 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Breaks:
 getdns-utils (<< 1.2.1-1~),
Replaces:
 getdns-utils (<< 1.2.1-1~),
Description: modern asynchronous DNS API (stub resolver)
 getdns is a modern asynchronous DNS API.  It implements DNS entry
 points from a design developed and vetted by application developers,
 in an API specification edited by Paul Hoffman.  This API intends to
 offer application developers a modernized and flexible way to access
 DNS security (DNSSEC) and other powerful new DNS features; a
 particular hope is to inspire application developers towards
 innovative security solutions in their applications.
 .
 This package contains stubby daemon - the DNS Privacy Stub Resolver.

=== debian/rules ===
--- 
+++ 
@@ -10,18 +10,14 @@
 %:
 	dh $@
 
-override_dh_autoreconf:
-	automake -a || true
-	dh_autoreconf
-
 override_dh_auto_configure:
 	dh_auto_configure -- \
-		--with-libevent \
-		--with-libev \
-		--with-libuv \
-		--with-trust-anchor=/usr/share/dns/root.key \
-		--with-current-date="$(CURRENT_DATE)" \
-		--with-stubby
+		-DBUILD_LIBEVENT2=ON \
+		-DBUILD_LIBEV=ON \
+		-DBUILD_LIBUV=ON \
+		-DPATH_TRUST_ANCHOR_FILE=/usr/share/dns/root.key \
+		-DCURRENT_DATE="$(CURRENT_DATE)" \
+		-DBUILD_STUBBY=ON
 
 override_dh_install:
 	-rm -rf $(CURDIR)/debian/tmp/usr/share/doc

=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/,uversionmangle=s/-?((rc|b|beta|a|alpha)\.?\d+)$/~$1/ \
https://getdnsapi.net/dist/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@

## getdns 1.7.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20 FATAL_ERROR)

if (POLICY CMP0075)
  cmake_policy(SET CMP0075 NEW)
endif ()

# The following must be set BEFORE doing project() or enable_language().
if (NOT CMAKE_BUILD_TYPE)
  message(STATUS "No build type defined; defaulting to 'RelWithDebInfo'")
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING
    "The type of build. Possible values are: Debug, Release, RelWithDebInfo and MinSizeRel.")
endif ()

set(PACKAGE "getdns")
set(PACKAGE_NAME "getdns")
set(PACKAGE_VERSION "1.7.3")
set(PACKAGE_BUGREPORT "team@getdnsapi.net")
set(PACKAGE_URL "https://getdnsapi.net")

# Dont forget to put a dash in front of the release candidate!!!
# That is how it is done with semantic versioning!
set(RELEASE_CANDIDATE "")

set(PACKAGE_STRING "${PACKAGE_NAME} ${PACKAGE_VERSION}${RELEASE_CANDIDATE}")
set(PACKAGE_TARNAME "${PACKAGE}-${PACKAGE_VERSION}${RELEASE_CANDIDATE}")

set(GETDNS_VERSION "${PACKAGE_VERSION}${RELEASE_CANDIDATE}")
set(GETDNS_NUMERIC_VERSION 0x01070200)
set(API_VERSION "December 2015")
set(API_NUMERIC_VERSION 0x07df0c00)


# Library version
# ---------------
# current:revision:age
# (binary-api-number):(which-binary-api-version):(how-many-nrs-backwardscompat)
# if source code changes increment revision
# if any interfaces have been added/removed/changed since last update then
#   increment current and set revision to 0
# if any interfaces have been added since the last public release then increment age
# if any interfaces have been removed or changed since the last public release then
#   set age to 0
#
# getdns-0.1.4 had libversion 0:0:0
# getdns-0.1.5 had libversion 1:0:0
# getdns-0.1.6 had libversion 1:1:0
# getdns-0.1.7 had libversion 1:2:1 (but should have had 2:0:1)
# getdns-0.1.8 had libversion 1:3:0 (but should have had 2:1:1)
# getdns-0.2.0 had libversion 2:2:1
# getdns-0.3.0 had libversion 3:3:2
# getdns-0.3.1 had libversion 3:4:2
# getdns-0.3.2 had libversion 3:5:2
# getdns-0.3.3 had libversion 3:6:2
# getdns-0.5.0 had libversion 4:0:3
# getdns-0.5.1 had libversion 4:1:3 (but should have been getdns-0.6.0)
# getdns-0.9.0 had libversion 5:0:4
# getdns-1.0.0 had libversion 5:1:4
# getdns-1.1.0 had libversion 6:0:0
# getdns-1.1.1 had libversion 6:1:0
# getdns-1.1.2 had libversion 7:0:1
# getdns-1.1.3 had libversion 7:1:1
# getdns-1.2.0 had libversion 8:0:2
# getdns-1.2.1 had libversion 8:1:2
# getdns-1.3.0 had libversion 9:0:3
# getdns-1.4.0 had libversion 10:0:0
# getdns-1.4.1 had libversion 10:1:0
# getdns-1.4.2 had libversion 10:2:0
# getdns-1.5.0 had libversion 11:0:1
# getdns-1.5.1 had libversion 11:1:1
# getdns-1.5.2 had libversion 11:2:1
# getdns-1.6.0 had libversion 11:3:1
# getdns-1.7.0 has libversion 12:0:2
set(GETDNS_VERSION_CURRENT 12)
set(GETDNS_VERSION_REVISION 0)
set(GETDNS_VERSION_AGE 2)

project(getdns VERSION ${PACKAGE_VERSION} LANGUAGES C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/")

include(CheckCSourceRuns)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CheckTypeSize)
include(CMakeDependentOption)
include(CTest)
include(GNUInstallDirs)
include(TestBigEndian)

include(TargetSharedLibraryExports)
include(TargetSharedLibraryVersion)

# Target Platform
if (WIN32 OR MINGW OR MSYS OR CYGWIN)
  set(HOSTOS "windows")
  set(GETDNS_ON_WINDOWS 1)
  set(USE_WINSOCK 1)
elseif (APPLE)
  set(HOSTOS "macos")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_DARWIN_C_SOURCE")
elseif (UNIX)
  set(HOSTOS "unix")

  if (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD" AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL "OpenBSD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_POSIX_C_SOURCE=200112L -D_XOPEN_SOURCE=600")
  endif ()
  if (${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
    set(LINUX 1)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_BSD_SOURCE -D_DEFAULT_SOURCE")
  elseif (${CMAKE_SYSTEM_NAME} STREQUAL "Solaris")
    set(SOLARIS 1)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D__EXTENSIONS_")
  endif ()
endif ()

test_big_endian(TARGET_IS_BIG_ENDIAN)
set(HAVE_TARGET_ENDIANNESS 1)

# Options.
option(ENABLE_SHARED "Build shared libraries." ON)
option(ENABLE_STATIC "Build static libraries." ON)
if ((NOT ENABLE_SHARED) AND (NOT ENABLE_STATIC))
  message(FATAL_ERROR "You must build either static or shared libraries.")
endif ()

option(ENABLE_DEBUG_ALL "Enable all debugging messages.")
cmake_dependent_option(ENABLE_DEBUG_REQ "Enable request debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
cmake_dependent_option(ENABLE_DEBUG_SCHED "Enable scheduling debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
cmake_dependent_option(ENABLE_DEBUG_STUB "Enable stub debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
cmake_dependent_option(ENABLE_DEBUG_DAEMON "Enable daemon debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
cmake_dependent_option(ENABLE_DEBUG_DNSSEC "Enable DNSSEC debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
cmake_dependent_option(ENABLE_DEBUG_SERVER "Enable server debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
cmake_dependent_option(ENABLE_DEBUG_ANCHOR "Enable anchor debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)

option(ENABLE_SHA1 "Enable SHA1 RRSIG support." ON)
option(ENABLE_SHA2 "Enable SHA256 and SHA512 RRSIG support." ON)
option(ENABLE_GOST "Enable GOST support." ON)
option(ENABLE_ECDSA "Enable ECDSA support." ON)
option(ENABLE_DSA "Enable DSA support." ON)
option(ENABLE_ED25519 "Enable ED25519 support." ON)
option(ENABLE_ED448 "Enable ED448 support." ON)

option(ENABLE_DRAFT_MDNS_SUPPORT "Enable draft mdns client support.")
option(ENABLE_EDNS_COOKIES "Enable EDNS cookies." ON)
option(ENABLE_NATIVE_STUB_DNSSEC "Enable native stub DNSSEC support." ON)
option(ENABLE_POLL_EVENTLOOP "Enable default eventloop based on poll." ON)
if (WIN32)
  option(ENABLE_STUB_ONLY "Restrict resolution modes to STUB." ON)
else()
  option(ENABLE_STUB_ONLY "Restrict resolution modes to STUB." OFF)
endif()
option(ENABLE_TCP_FAST_OPEN "Enable use of TCP Fast Open." ON)
option(ENABLE_UNBOUND_EVENT_API "Enable usage of libunbound's event API." ON)

option(BUILD_DOXYGEN "Build source documentation." OFF)
option(BUILD_EXAMPLES "Compile the example programs." OFF)
option(BUILD_GETDNS_QUERY "Compile and install the getdns_query tool." ON)
option(BUILD_GETDNS_SERVER_MON "Compile and install the getdns_server_mon tool." ON)
option(BUILD_STUBBY "Compile and install stubby, the (stub) resolver daemon." OFF)

option(BUILD_LIBEV "Build libev support library if available." ON)
option(BUILD_LIBEVENT2 "Build libevent2 support library if available." ON)
option(BUILD_LIBUV "Build libuv support library available." ON)

option(USE_LIBIDN2 "Use libidn2 if available." ON)
option(USE_GNUTLS "Use GnuTLS for TLS connections." OFF)

option(FORCE_COMPAT_STRPTIME "Force use of internal strptime when cross-compiling." OFF)

# Above names chosen for user consistency. Now define substituted names.
set(REQ_DEBUG ${ENABLE_DEBUG_REQ})
set(SCHED_DEBUG ${ENABLE_DEBUG_SCHED})
set(STUB_DEBUG ${ENABLE_DEBUG_STUB})
set(DAEMON_DEBUG ${ENABLE_DEBUG_DAEMON})
set(SEC_DEBUG ${ENABLE_DEBUG_DNSSEC})
set(SERVER_DEBUG ${ENABLE_DEBUG_SERVER})
set(ANCHOR_DEBUG ${ENABLE_DEBUG_ANCHOR})
set(EDNS_COOKIES ${ENABLE_EDNS_COOKIES})

set(USE_SHA1 ${ENABLE_SHA1})
set(USE_SHA2 ${ENABLE_SHA2})
set(USE_GOST ${ENABLE_GOST})
set(USE_ECDSA ${ENABLE_ECDSA})
set(USE_DSA ${ENABLE_DSA})
set(USE_ED25519 ${ENABLE_ED25519})
set(USE_ED448 ${ENABLE_ED448})

set(HAVE_MDNS_SUPPORT ${ENABLE_DRAFT_MDNS_SUPPORT})
set(STUB_NATIVE_DNSSEC ${ENABLE_NATIVE_STUB_DNSSEC})

set(USE_LIBEV ${BUILD_LIBEV})
set(USE_LIBEVENT2 ${BUILD_LIBEVENT2})
set(USE_LIBUV ${BUILD_LIBUV})

option(ENABLE_DEBUG_KEEP_CONNECTIONS_OPEN "Disable connection idle timeout. Do not enable.")
mark_as_advanced(ENABLE_DEBUG_KEEP_CONNECTIONS_OPEN)
set(KEEP_CONNECTIONS_OPEN_DEBUG ${ENABLE_DEBUG_KEEP_CONNECTIONS_OPEN})

# Options variables.
string(TIMESTAMP timestamp "%Y-%m-%dT%H:%M:%SZ")
set(CURRENT_DATE "${timestamp}" CACHE STRING "Current date of the compilation, set to fixed date for reproducible builds.")
set(DNSSEC_ROADBLOCK_AVOIDANCE ON CACHE BOOL "Enable/disable DNSSEC roadblock avoidance.")
set(FD_SETSIZE "" CACHE STRING "Set maximum file descriptor number that can be used by select.")
set(MAX_UDP_BACKOFF 1000 CACHE STRING "Set the maximum number of messages that can be sent to other upstreams before the upstream which has previously timed out will be tried again.")
if (WIN32)
  # BUG! Don't hardcode the Windows directory and drive.
  set(hostsfile "C:/Windows/System32/Drivers/etc/hosts")
else ()
  set(hostsfile "/etc/hosts")
endif ()
set(PATH_HOSTS "${hostsfile}" CACHE STRING "Set the static table lookup for hostnames path.")
set(PATH_RESOLVCONF "/etc/resolv.conf" CACHE STRING "Set the resolver configuration file path. Not used on Windows, where values are retrieved via GetNetworkParams().")
set(PATH_TRUST_ANCHOR_FILE "${CMAKE_INSTALL_FULL_SYSCONFDIR}/unbound/getdns-root.key" CACHE STRING "Default location of the trust anchor file.")

# Ensure option variables in config.h that get values from the above are
# defined, and so will actually appear in config.h.
set(GETDNS_FN_HOSTS 1)
set(GETDNS_FN_RESOLVCONF 1)
set(TRUST_ANCHOR_FILE 1)
set(UDP_MAX_BACKOFF 1)

# Options not exposed in autoconf.
set(DRAFT_RRTYPES 1)
set(EDNS_COOKIE_OPCODE 10)
set(EDNS_COOKIE_ROLLOVER_TIME "(24*60*60)")
set(EDNS_PADDING_OPCODE 12)
set(MAX_CNAME_REFERRALS 100)
set(MAXIMUM_UPSTREAM_OPTION_SPACE 3000)

# Values derived from options.
set(GETDNS_COMPILATION_COMMENT "${PACKAGE_NAME} ${GETDNS_VERSION} configured on ${CURRENT_DATE} for the ${API_VERSION} version of the API")

# Compiler flags
if (MSVC)
  # The Visual Studio C compiler is C90 with some of C99 and C11.
  # So full on warnings are not appropriate.
  add_compile_options(/W2)
else ()
  add_compile_options(-Wall -Wextra -Wpedantic)
endif ()

# Windows. Uh-oh.
set(getdns_system_libs "")
set(static_lib_suffix "")
if (DEFINED GETDNS_ON_WINDOWS)
  set(static_lib_suffix "_static")
  list(APPEND getdns_system_libs
    "ws2_32"
    "crypt32"
    "gdi32"
    "iphlpapi"
    "psapi"
    "userenv"
    )
endif ()

# Check for include files
check_include_file(assert.h HAVE_ASSERT_H)
check_include_file(inttypes.h HAVE_INTTYPES_H)
check_include_file(limits.h HAVE_LIMITS_H)
check_include_file(sys/limits.h HAVE_SYS_LIMITS_H)
check_include_file(stdarg.h HAVE_STDARG_H)
check_include_file(stddef.h HAVE_STDDEF_H)
check_include_file(stdint.h HAVE_STDINT_H)
check_include_file(stdio.h HAVE_STDIO_H)
check_include_file(stdlib.h HAVE_STDLIB_H)
check_include_file(string.h HAVE_STRING_H)
check_include_file(strings.h HAVE_STRINGS_H)
check_include_file(time.h HAVE_TIME_H)
check_include_file(unistd.h HAVE_UNISTD_H)

check_include_file(fcntl.h HAVE_FCNTL_H)

check_include_file(signal.h HAVE_SIGNAL_H)
check_include_file(sys/poll.h HAVE_SYS_POLL_H)
check_include_file(poll.h HAVE_POLL_H)
check_include_file(resource.h HAVE_RESOURCE_H)
check_include_file(sys/types.h HAVE_SYS_TYPES_H)
check_include_file(sys/stat.h HAVE_SYS_STAT_H)

check_include_file(endian.h HAVE_ENDIAN_H)
check_include_file(netdb.h HAVE_NETDB_H)
check_include_file(arpa/inet.h HAVE_ARPA_INET_H)
check_include_file(netinet/in.h HAVE_NETINET_IN_H)
check_include_file(sys/select.h HAVE_SYS_SELECT_H)
check_include_file(sys/socket.h HAVE_SYS_SOCKET_H)
check_include_file(sys/sysctl.h HAVE_SYS_SYSCTL_H)
check_include_file(sys/time.h HAVE_SYS_TIME_H)
check_include_file(sys/wait.h HAVE_SYS_WAIT_H)

check_include_file(windows.h HAVE_WINDOWS_H)
check_include_file(winsock.h HAVE_WINSOCK_H)
check_include_file(winsock2.h HAVE_WINSOCK2_H)
check_include_file(ws2tcpip.h HAVE_WS2TCPIP_H)

# Check for include declarations
check_symbol_exists(getentropy unistd.h HAVE_DECL_GETENTROPY)
if (DEFINED GETDNS_ON_WINDOWS)
  set(CMAKE_REQUIRED_LIBRARIES ${getdns_system_libs})
  check_symbol_exists(inet_pton ws2tcpip.h HAVE_DECL_INET_PTON)
  check_symbol_exists(inet_ntop ws2tcpip.h HAVE_DECL_INET_NTOP)
else ()

=== stubby/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,10 @@
 
 set(PACKAGE "stubby")
 set(PACKAGE_NAME "Stubby")
-set(PACKAGE_VERSION "0.3.0")
+set(PACKAGE_VERSION_MAJOR 0)
+set(PACKAGE_VERSION_MINOR 4)
+set(PACKAGE_VERSION_RELEASE 3)
+set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_RELEASE}")
 set(PACKAGE_BUGREPORT "team@getdnsapi.net")
 set(RELEASE_CANDIDATE "")
 
@@ -23,7 +26,14 @@
 set(STUBBY_PACKAGE "${PACKAGE}")
 set(STUBBY_PACKAGE_STRING "${PACKAGE_STRING}")
 
-project (stubby VERSION ${PACKAGE_VERSION} LANGUAGES C)
+if (WIN32)
+  option(PATCH_LEVEL_GIT "Get patch level from git." OFF)
+
+  set(STUBBY_ON_WINDOWS 1)
+  project (stubby VERSION ${PACKAGE_VERSION} LANGUAGES C RC)
+else()
+  project (stubby VERSION ${PACKAGE_VERSION} LANGUAGES C)
+endif()
 
 list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
 
@@ -37,6 +47,10 @@
 if (Libsystemd_FOUND)
   option(ENABLE_SYSTEMD "Enable systemd support." ON)
 endif()
+option(ENABLE_GETDNS_STATIC_LINK "Link GetDNS statically." ON)
+if (ENABLE_GETDNS_STATIC_LINK)
+  set(GETDNS_STATIC ON)
+endif ()
 
 # Directories
 if (DEFINED CMAKE_INSTALL_FULL_RUNSTATEDIR)
@@ -55,8 +69,27 @@
 
 find_package(Libyaml REQUIRED)
 
-if (WIN32)
-  set(STUBBY_ON_WINDOWS 1)
+if (STUBBY_ON_WINDOWS)
+  check_include_file(windows.h HAVE_WINDOWS_H)
+
+  option(ENABLE_WINDOWS_SERVICE "Enable Windows service interface." ON)
+
+  find_program(CMAKE_MC_COMPILER mc.exe DOC "path to message compiler")
+  if (NOT CMAKE_MC_COMPILER)
+    message(FATAL_ERROR "message compiler not found: required to build")
+  endif (NOT CMAKE_MC_COMPILER)
+  message(STATUS "Found message compiler: ${CMAKE_MC_COMPILER}")
+  mark_as_advanced(CMAKE_MC_COMPILER)
+
+  set(PACKAGE_VERSION_PATCH 0)
+  if (PATCH_LEVEL_GIT)
+    execute_process(COMMAND git describe --long OUTPUT_VARIABLE ver)
+    if (ver)
+      string(REGEX REPLACE "v[^-]*-([0-9]+)-.*" "\\1" PACKAGE_VERSION_PATCH ${ver})
+    endif ()
+  endif ()
+else ()
+  set(ENABLE_WINDOWS_SERVICE OFF)
 endif ()
 
 check_include_file(os/log.h HAVE_OS_LOG_H)
@@ -66,6 +99,7 @@
 option(ENABLE_DEBUG_ALL "Enable all debugging messages.")
 cmake_dependent_option(ENABLE_DEBUG_SERVER "Enable server debugging messages." OFF "NOT ENABLE_DEBUG_ALL" ON)
 set(SERVER_DEBUG ${ENABLE_DEBUG_SERVER})
+
 
 
 check_symbol_exists(getopt "unistd.h" HAVE_GETOPT)
@@ -85,8 +119,34 @@
 set(ETCDIR "${STUBBYCONFDIR}")
 configure_file(doc/stubby.1.in stubby.1 @ONLY)
 
+if (STUBBY_ON_WINDOWS)
+  set(VER_PRODUCTVERSION "${PACKAGE_VERSION_MAJOR},${PACKAGE_VERSION_MINOR},${PACKAGE_VERSION_RELEASE},${PACKAGE_VERSION_PATCH}")
+  set(VER_PRODUCTVERSION_STR "${PACKAGE_VERSION}${RELEASE_CANDIDATE}")
+  set(PACKAGE_VERSION "${PACKAGE_VERSION_MAJOR}.${PACKAGE_VERSION_MINOR}.${PACKAGE_VERSION_RELEASE}.${PACKAGE_VERSION_PATCH}")
+  configure_file(src/windows/stubby.rc.in stubby.rc @ONLY)
+  configure_file(src/windows/stubby.ico stubby.ico COPYONLY)
+  configure_file(package_version.in package_version @ONLY)
+  if (ENABLE_WINDOWS_SERVICE)
+    configure_file(src/windows/stubres.rc.in stubres.rc @ONLY)
+  endif ()
+
+  add_custom_command(
+    OUTPUT service.rc service.h
+    MAIN_DEPENDENCY src/windows/service.mc
+    COMMAND ${CMAKE_MC_COMPILER}
+    ARGS -U
+         -n
+         -r ${CMAKE_CURRENT_BINARY_DIR}
+         ${CMAKE_CURRENT_SOURCE_DIR}/src/windows/service.mc
+    )
+endif ()
+
 add_executable(stubby
   src/stubby.c
+  src/configfile.c
+  src/log.c
+  src/server.c
+  src/util.c
   src/yaml/convert_yaml_to_json.c
   src/sldns/sbuffer.c
   )
@@ -94,6 +154,20 @@
   target_sources(stubby PRIVATE src/compat/getopt.c)
   target_include_directories(stubby PRIVATE src/compat)
 endif ()
+if (STUBBY_ON_WINDOWS)
+  target_sources(stubby PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/stubby.rc)
+endif ()
+if (ENABLE_WINDOWS_SERVICE)
+  target_sources(stubby PRIVATE src/windows/service.c ${CMAKE_CURRENT_BINARY_DIR}/service.h)
+  target_include_directories(stubby PRIVATE src/windows ${CMAKE_CURRENT_BINARY_DIR})
+
+  add_library(stubres SHARED
+    src/windows/stubres.c
+    ${CMAKE_CURRENT_BINARY_DIR}/service.rc
+    ${CMAKE_CURRENT_BINARY_DIR}/stubres.rc
+    )
+  set_property(TARGET stubres PROPERTY C_STANDARD 11)
+endif()
 
 target_include_directories(stubby PRIVATE src ${CMAKE_CURRENT_BINARY_DIR})
 target_link_libraries(stubby PRIVATE Libyaml::Libyaml)
@@ -109,20 +183,34 @@
 endif ()
 set_property(TARGET stubby PROPERTY C_STANDARD 11)
 
-install(TARGETS stubby DESTINATION bin)
+install(TARGETS stubby RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} )
+if (ENABLE_WINDOWS_SERVICE)
+  install(TARGETS stubres LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+endif ()
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/stubby.1 DESTINATION share/man/man1)
 install(FILES AUTHORS COPYING ChangeLog NEWS README.md DESTINATION share/doc/stubby)
 
 # Ensure the file gets CRLF line endings on Windows.
 file(GENERATE OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/stubby.yml INPUT ${CMAKE_CURRENT_SOURCE_DIR}/stubby.yml.example)
-# Copy to destination iff no destination file exists.
+# Copy stubby.yml to destination iff no destination file exists.
+# This is complicated by (a) not being able to use generators, due to
+# CMake minimum version requirement, and (b) to account for DESTDIR.
+# And in the latter case, if we're adding DESTDIR to the start of the
+# path, we must on Windows remove any initial drive letter. That's what
+# INSTALL appears to do.
 install(CODE "\
-  set(targetdir ${STUBBYCONFDIR})\n\
-  if (\$ENV{DESTDIR})\n\
-    set(targetdir \$ENV{DESTDIR}/\${targetdir})\n\
+  set(targetdir \"${STUBBYCONFDIR}\")\n\
+  set(destdir \"\$ENV{DESTDIR}\")\n\
+  if (destdir)\n\
+    string(REGEX REPLACE \"^([A-Z]:)?/(.*)\" \"\\\\2\" newtarget \"\${targetdir}\")\n\
+    if (newtarget)\n\
+      set(targetdir \"\${newtarget}\")\n\
+    endif ()\n\
+    set(targetdir \"\${destdir}/\${newtarget}\")\n\
   endif ()\n\
-  if (NOT EXISTS \${targetdir}/stubby.yml)\n\
-    file(COPY ${CMAKE_CURRENT_BINARY_DIR}/stubby.yml DESTINATION \${targetdir})\n\
+  if (NOT EXISTS \"\${targetdir}/stubby.yml\")\n\
+    file(COPY \"${CMAKE_CURRENT_BINARY_DIR}/stubby.yml\" DESTINATION \"\${targetdir}\")\n\
+    message(\"-- Installing: \${targetdir}/stubby.yml\")\n\
   endif ()")
 
 if (APPLE)

=== debian/changelog ===
getdns (1.7.3-3) unstable; urgency=medium

  * Exclude build-time tests that attempt networking
  * Stubby autopkgtest:
    - mark as needs-internet, needs-root, isolation-container
    - fix outdated config and addresses
  * Add myself to Uploaders

 -- Andrew Bower <andrew@bower.uk>  Tue, 26 Aug 2025 21:08:50 +0100

getdns (1.7.3-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.
  * stubby: patch to update adguard example (LP: #1989104)
  * make openssl dependency explicit for DANE support
  * fix broken HTML in "don't phone home" patch, simplify it
    and mark in DEP-3 that it is now forwarded upstream

 -- Andrew Bower <andrew@bower.uk>  Sun, 10 Aug 2025 22:33:40 +0100

getdns (1.7.3-1) experimental; urgency=medium

  * Team upload.

  [ Andrew Bower ]
  * New upstream version (Closes: #1025781, #1025741)
  * drop patches included upstream
  * catch new symbols and restore missing ones (Closes: #1023663)
  * add salsa CI pipeline
  * ditch unnecessary orig tar filtering since autotools dropped
  * omit build flags from bin for reproducibility
  * remove superfluous lintian override
  * stubby service integration
    - add initscript (Closes: #1008931)
    - add hardened runit service directory
    - be a notify-type systemd service
  * d/control:
    - add B-D on pkgconf and libsystemd-dev
    - normalise whitespace
    - update S-V to 4.7.2, no changes needed
    - dev package does not need shlib:Depends
  * d/copyright: fix omissions and bring up to date
  * add d/.gitignore
  * Backport patch trimming server list in man page
  * Backport patch updating stubby server examples

 -- Andrew Bower <andrew@bower.uk>  Thu, 03 Jul 2025 10:24:46 +0100

getdns (1.6.0-3.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Debian Janitor ]
  * Remove constraints unnecessary since buster (oldstable):
    + stubby: Drop versioned constraint on getdns-utils in Replaces.
    + stubby: Drop versioned constraint on getdns-utils in Breaks.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Bump debhelper from old 11 to 13.
    + debian/rules: Drop --fail-missing argument to dh_missing, which is now the
      default.
  * Set debhelper-compat version in Build-Depends.
  * Update standards version to 4.6.2, no changes needed.

  [ Andrew Bower ]
  * Patch tests to fix FTBFS with gcc-14. (Closes: #1074989)

 -- Andrew Bower <andrew@bower.uk>  Mon, 03 Feb 2025 07:11:36 +0000

getdns (1.6.0-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062103

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 17:05:25 +0000

getdns (1.6.0-3) unstable; urgency=medium

  * Team upload.

  [ Scott Kitterman ]
  * Remove myself from uploaders

  [ Roger Shimizu ]
  * debian/patches:Add patch from upstream to fix FindLibidn2.cmake
    (Closes: #1015065).
  * Revert "d/control: Mark libgetdns-dev as Multi-Arch: same".
  * debian/upstream/metadata: Remove entry of Homepage.
  * lintian-overrides: Add entry for source-is-missing [spec/index.html]

 -- Roger Shimizu <rosh@debian.org>  Sun, 31 Jul 2022 20:12:47 +0900

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,29 @@
 Source: getdns
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: getdns packagers <getdns@packages.debian.org>
+Maintainer: getdns packagers <getdns@packages.debian.org>
 Uploaders:
  Ondřej Surý <ondrej@debian.org>,
- Scott Kitterman <scott@kitterman.com>,
  Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
-Build-Depends:
+ Andrew Bower <andrew@bower.uk>
+Build-Depends: dpkg-dev (>= 1.22.5),
  check,
  cmake,
- debhelper (>= 11~),
+ debhelper-compat (= 13),
  libbsd-dev,
  libev-dev,
  libevent-dev,
  libexpat-dev,
  libidn2-dev,
  libldns-dev,
+ libssl-dev,
  libunbound-dev,
  libuv1-dev,
  libyaml-dev,
  unbound-anchor,
-Standards-Version: 4.3.0
+ libsystemd-dev,
+ pkgconf,
+ dh-sequence-runit,
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Section: libs
 Homepage: https://getdnsapi.net/
@@ -30,11 +33,10 @@
 Package: libgetdns-dev
 Section: libdevel
 Architecture: any
+Depends:
+ libgetdns10t64 (= ${binary:Version}),
+ ${misc:Depends},
 Multi-Arch: same
-Depends:
- libgetdns10 (= ${binary:Version}),
- ${misc:Depends},
- ${shlibs:Depends},
 Description: modern asynchronous DNS API (development)
  getdns is a modern asynchronous DNS API.  It implements DNS entry
  points from a design developed and vetted by application developers,
@@ -46,7 +48,8 @@
  .
  This is the full development version of the library.
 
-Package: libgetdns10
+Package: libgetdns10t64
+Provides: ${t64:Provides}
 Multi-Arch: same
 Architecture: any
 Depends:
@@ -54,8 +57,10 @@
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
+ libgetdns10 (<< ${source:Version}),
  libgetdns0 (>= 0.1.5-1~),
 Replaces:
+ libgetdns10,
  libgetdns0 (>= 0.1.5-1~),
 Description: modern asynchronous DNS API (shared library)
  getdns is a modern asynchronous DNS API.  It implements DNS entry
@@ -72,7 +77,7 @@
 Architecture: any
 Section: net
 Depends:
- libgetdns10 (= ${binary:Version}),
+ libgetdns10t64 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Recommends:
@@ -91,14 +96,14 @@
 Package: stubby
 Architecture: any
 Section: net
+Pre-Depends:
+ ${misc:Pre-Depends},
 Depends:
- libgetdns10 (= ${binary:Version}),
+ libgetdns10t64 (= ${binary:Version}),
  ${misc:Depends},
  ${shlibs:Depends},
 Breaks:
- getdns-utils (<< 1.2.1-1~),
-Replaces:
- getdns-utils (<< 1.2.1-1~),
+ ${runit:Breaks},
 Description: modern asynchronous DNS API (stub resolver)
  getdns is a modern asynchronous DNS API.  It implements DNS entry
  points from a design developed and vetted by application developers,

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,7 @@
 
 export DPKG_GENSYMBOLS_CHECK_LEVEL=4
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_CFLAGS_MAINT_APPEND = -DNO_NETWORKING_IN_TEST
 
 %:
 	dh $@
@@ -24,8 +25,7 @@
 	dh_install -X.la
 
 override_dh_missing:
-	dh_missing -X.la --fail-missing
+	dh_missing -X.la
 
 override_dh_auto_test:
-	# remote tests fail when there's no connectivity or the connectivity is restrained
-	-dh_auto_test
+	dh_auto_test

=== debian/tests/control ===
Tests: stubby
Depends: stubby, knot-dnsutils, procps
Restrictions: allow-stderr, skippable, needs-internet, needs-root, isolation-container
